<template>
  <form v-if="model" action="https://test.customizer.amigo.ru/api/calculate" method="POST" id="form" class="form">
    <label class="label">
      Ширина
    </label>
    <input type="number" name="form-width" id="form-width" class="input" placeholder="Введите ширину..." v-model.number="sizes.width" required>
    <label class="label">
      Высота
    </label>
    <input type="number" name="form-height" id="form-height" class="input" placeholder="Введите высоту..." v-model.number="sizes.height" required>
    <button type="submit" class="button" @click="calculate">В корзину</button>
    <div v-if="result">
      <div v-if="result.price" class="result">Результирующая цена: {{result.price}}руб</div>
      <div v-else class="result error">{{result.errorMessage}}</div>
    </div>
    <div v-if="error" class="result error">{{error}}</div>
  </form>
</template>
<script>
import { mapState, mapActions, mapMutations } from 'vuex'

export default {
  name: 'Form',
  data() {
    return {
      sizes: {
        width: 0,
        height: 0
      },
      error: null
    }
  },
  computed: mapState({
    type: state => state.models.type,
    model: state => state.models.model,
    submodel: state => state.models.submodel,
    material: state => state.models.material,
    result: state => state.models.result
  }),
  methods: {
    ...mapActions('models', [
      'requestCalculation'
    ]),
    ...mapMutations('models', [
      'addToCart' 
    ]),
    calculate() {
      event.preventDefault();
      if (this.submodel && this.material) {
        let options = [];
        let optionsCart = [];
        const list = this.submodel.options;
        if (list) {
          for (let i = 0; i < list.length; i++) {
            if (list[i].option_default && list[i].type !== "T") {
              options.push(list[i].option_default);
              optionsCart.push({
                value: list[i].option_default,
                code_1c: list[i].code_1c
              });
            } else {
              options.push(list[i].id);
              optionsCart.push({
                value: list[i].id,
                code_1c: list[i].code_1c
              });
            }
          }
        }
        this.requestCalculation({
          material: this.material.id, 
          model: this.submodel.id, 
          options: options, 
          sizes: this.sizes, 
          uuid: ""
        }).then(res => {
          if (!res.errorMessage) {
            this.addToCart({
              typeName: this.type.name,
              typeId: this.type.id,
              modelName: this.model.name,
              modelId: this.model.id,
              submodelName: this.submodel.name,
              submodelId: this.submodel.id,
              materialName: this.material.name,
              options: optionsCart,
              width: this.sizes.width,
              height: this.sizes.height,
              result: (Math.round(this.result.price * 100) / 100)
            });
          }
        });
        this.error = null;
      } else if (this.model && this.material) {
        let options = [];
        let optionsCart = [];
        const list = this.model.options;
        if (list) {
          for (let i = 0; i < list.length; i++) {
            if (list[i].option_default && list[i].type !== "T") {
              options.push(list[i].option_default);
              optionsCart.push({
                value: list[i].option_default,
                code_1c: list[i].code_1c
              });
            } else {
              options.push(list[i].id);
              optionsCart.push({
                value: list[i].id,
                code_1c: list[i].code_1c
              });
            }
          }
        }
        this.requestCalculation({
          material: this.material.id, 
          model: this.model.id, 
          options: options, 
          sizes: this.sizes, 
          uuid: ""
        }).then(res => {
          if (!res.errorMessage) {
            this.addToCart({
              typeName: this.type.name,
              typeId: this.type.id,
              modelName: this.model.name,
              modelId: this.model.id,
              submodelName: '',
              submodelId: '',
              materialName: this.material.name,
              options: optionsCart,
              width: this.sizes.width,
              height: this.sizes.height,
              result: (Math.round(this.result.price * 100) / 100)
            });
          }
        });
        this.error = null;
      } else if (!this.model) {
        this.error = "Пожалуйста, выберите модель";
      } else {
        this.error = "Пожалуйста, выберите материал";
      }
    }
  }
}
</script>
<style>
.form {
  padding: 20px 0;
}
.label, 
.input {
  display: block;
  font-size: 18px;
  color: #000;
  margin: 0 0 10px;
}
.button {
  display: block;
  width: 200px;
  height: 40px;
  font-size: 18px;
  line-height: 38px;
  text-transform: uppercase;
  letter-spacing: 1px;
  color: #fff;
  border: 1px solid #000;
  border-radius: 0;
  background-color: #000;
  margin: 24px 0 0;
  padding: 0;
  transition: 0.3s;
  cursor: pointer;
}
.button:hover {
  color: #000;
  background-color: #fff;
}
.result {
  font-size: 16px;
  color: #000;
  margin: 40px 0 0;
}
.result.error {
  color: #ff0000;
}
</style>